/**
  *  \file lregexp.h
  */
#ifndef LREGEXP_H_INCLUDED
#define LREGEXP_H_INCLUDED

#include <string>
#include <sys/types.h>
#include <regex.h>
#include "lispy.h"

class LRegResult;

class LRegExp : public LSelfEval {
    regex_t regexp;
 public:
    LRegExp(std::string re);
    ~LRegExp();

    std::string toString();

    friend class LRegResult;
};

class LRegResult : public LSelfEval {
    enum { MAX_MATCH = 10 };
    std::string value;
    regmatch_t matches[MAX_MATCH];
    bool ok;
 public:
    LRegResult(std::string value, const LRegExp& expr);
    ~LRegResult();

    std::string toString();

    LPtr getMatch(int n) const;

    bool isOK() const
        { return ok; }
};

void initRegexp();

#endif
